using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;

namespace Labyrinth
{
    public partial class Form1 : Form
    {
        int roomSize = 5;
        Labyrinth labDFS, labTurnCount;
        LabPathFinder pathfinder;

        LabyrinthVisualisation labVisDFS, labVisTurnCount;
        Image imageDFS, imageTurnCount;


        public Form1()
        {
            InitializeComponent();

            findPathButton.Enabled = false;
        }

        private void startButton_Click(object sender, EventArgs e)
        {
            //generate the labyrinth
            int n = (int)labyrinthSizeDisplay.Value;
            labDFS = new Labyrinth(n, (byte)labyrinthLoosenessDisplay.Value);
            labTurnCount = labDFS.Clone(false);

            pathfinder = new LabPathFinder();

            findPathButton.Enabled = true;

            //draw it
            if (visualisationOnOffInput.Checked)
            {
                imageDFS = new Bitmap(n * roomSize, n * roomSize);
                imageTurnCount = new Bitmap(n * roomSize, n * roomSize);

                labVisDFS = new LabyrinthVisualisation(imageDFS, labDFS, roomSize);
                labVisTurnCount = new LabyrinthVisualisation(imageTurnCount, labTurnCount, roomSize);

                pictureBox1.Image = imageDFS;
                pictureBox1.Width = pictureBox1.Image.Width + 2;
                pictureBox1.Height = pictureBox1.Image.Height + 2;
            }
        }

        private void findPathButton_Click(object sender, EventArgs e)
        {
            if (labDFS != null && labTurnCount != null && pathfinder != null)
            {
                // find path through the labyrinth
                pathfinder.Labyrinth = labDFS;
                pathfinder.FindWayDFS();
                
                // find path through the labyrinth
                pathfinder.Labyrinth = labTurnCount;
                pathfinder.FindWayTurnCounter();
                
                // redraw
                if (labVisDFS != null && labVisTurnCount != null)
                {
                    labVisDFS.Draw();
                    labVisTurnCount.Draw();

                    if (toDFSVis.Checked)
                    {
                        pictureBox1.Image = imageDFS;
                    }
                    else
                    {
                        pictureBox1.Image = imageTurnCount;
                    }
                }
            }
        }

        private void toDFSVis_CheckedChanged(object sender, EventArgs e)
        {
            if (toDFSVis.Checked)
            {
                toTurnCountVis.Checked = false;
                pictureBox1.Image = imageDFS;
            }
        }

        private void toTurnCountVis_CheckedChanged(object sender, EventArgs e)
        {
            if (toTurnCountVis.Checked)
            {
                toDFSVis.Checked = false;
                pictureBox1.Image = imageTurnCount;
            }
        }

        private void buttonExp_Click(object sender, EventArgs e)
        {
            StatisticExperiments exp = new StatisticExperiments();
            exp.Run();
        }
    }
}